<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesSSCN_RF_1 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "inf",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 11,
            'size' =>2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "razao_social",
            'position' => 13,
            'size' => 70,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "expansao",
            'position' => 83,
            'size' => 33,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['inf'] = substr($values, 8, 2);
        $newValues['bloco'] = substr($values, 10, 2);
        $newValues['razao_social'] = substr($values, 12, 70);
        $newValues['expansao'] = substr($values, 82, 33);
        
        $this->setColumnsValues($newValues);
    }
}