<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeSSCN_SF_1 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "inf",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 11,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "qtde_inscricoes",
            'position' => 13,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "numero_inscricao",
            'position' => 16,
            'size' => 15,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "numero_consulta",
            'position' => 31,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "data_consulta",
            'position' => 41,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "data_situacao",
            'position' => 49,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "expansao",
            'position' => 57,
            'size' => 59,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['inf'] = substr($values, 8, 2);
        $newValues['bloco'] = substr($values, 10, 2);
        $newValues['qtde_inscricoes'] = substr($values, 12, 3);
        $newValues['numero_inscricao'] = substr($values, 15, 15);
        $newValues['numero_consulta'] = substr($values, 30, 10);
        $newValues['data_consulta'] = substr($values, 40, 8);
        $newValues['data_situacao'] = substr($values, 48, 8);
        $newValues['expansao'] = substr($values, 56, 59);
        
        $this->setColumnsValues($newValues);
    }
}