<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeN270_00 extends Record {
    public $name = "bad_check_detail";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type_rule",
            'position' => 5,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "data_ocor",
            'position' => 7,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cheque",
            'position' => 15,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "alinea",
            'position' => 25,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "quantity",
            'position' => 30,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "value",
            'position' => 35,
            'size' => 15,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "nu_bco",
            'position' => 50,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "no_bco",
            'position' => 53,
            'size' => 14,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "agency",
            'position' => 67,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "city",
            'position' => 71,
            'size' => 30,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "uf",
            'position' => 101,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 103,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 113,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ]
    ];

    public function __construct($values = null) {
        $this->createColumns();

        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['sub_type_rule'] = substr($values, 4, 2);
        $newValues['data_ocor'] = substr($values, 6, 8);
        $newValues['cheque'] = substr($values, 14, 10);
        $newValues['alinea'] = substr($values, 24, 5);
        $newValues['quantity'] = substr($values, 29, 5);
        $newValues['value'] = substr($values, 34, 15);
        $newValues['nu_bco'] = substr($values, 49, 3);
        $newValues['no_bco'] = substr($values, 52, 14);
        $newValues['agency'] = substr($values, 66, 4);
        $newValues['city'] = substr($values, 70, 30);
        $newValues['uf'] = substr($values, 100, 2);
        $newValues['filler'] = substr($values, 102, 10);
        $newValues['filler'] = substr($values, 112, 3);
        
        $this->setColumnsValues($newValues);
    }   
}